section \<open>Context-free language as inductive predicate\<close>

theory Parentheses
imports Main
begin

subsection \<open>Two grammars\<close>

text \<open>The alphabet:\<close>

datatype alphabet = Left | Right

type_synonym word = "alphabet list"
abbreviation "left \<equiv> [Left]"
abbreviation "right \<equiv> [Right]"


text \<open>Standard grammar:\<close>

inductive S :: "word \<Rightarrow> bool"
where
  S1: "S []"
| S2: "S w \<Longrightarrow> S (left @ w @ right)"
| S3: "S v \<Longrightarrow> S w \<Longrightarrow> S (v @ w)"


text \<open>Alternative grammar:\<close>

inductive T :: "word \<Rightarrow> bool"
where
  T1: "T []"
| T23: "T v \<Longrightarrow> T w \<Longrightarrow> T (v @ (left @ w @ right))"


subsection \<open>Equivalence proof\<close>

theorem "S w \<longleftrightarrow> T w"
  sorry

end
