theory Currying
imports Main
begin

lemma "(A \<and> B \<longrightarrow> C) \<longrightarrow> (A \<longrightarrow> B \<longrightarrow> C)"
  \<comment> \<open>curry\<close>
  sorry

lemma "(A \<longrightarrow> B \<longrightarrow> C) \<longrightarrow> (A \<and> B \<longrightarrow> C)"
  \<comment> \<open>uncurry\<close>
  sorry

lemma "((\<exists>x \<in> A. B x) \<longrightarrow> C) \<longrightarrow> (\<forall>x \<in> A. B x \<longrightarrow> C)"
  \<comment> \<open>dependent curry\<close>
  sorry

lemma "(\<forall>x \<in> A. B x \<longrightarrow> C) \<longrightarrow> ((\<exists>x \<in> A. B x) \<longrightarrow> C)"
  \<comment> \<open>dependent uncurry\<close>
  sorry

lemma "(A \<or> B \<longrightarrow> C) \<longrightarrow> (A \<longrightarrow> C) \<and> (B \<longrightarrow> C)"
  \<comment> \<open>disjunctive curry\<close>
  sorry

lemma "(A \<longrightarrow> C) \<and> (B \<longrightarrow> C) \<longrightarrow> (A \<or> B \<longrightarrow> C)"
  \<comment> \<open>disjunctive uncurry\<close>
  sorry

end