theory Rules
imports Main
begin

section \<open>Exercise\<close>

text \<open>
  \<triangleright> Produce standard natural deduction rules as proven theorems,
    e.g. by Query on the theory, or as explicit statements with
    (automated proof).

    \<^item> predicate-logic
      \<open>A \<and> B\<close>  \<open>A \<or> B\<close>  \<open>\<not> A\<close>
      \<open>A \<longrightarrow> B\<close>  \<open>A \<longleftrightarrow> B\<close>
      \<open>\<forall>x. P x\<close>  \<open>\<exists>x. P x\<close>

    \<^item> predicate-logic with set-constraints
      \<open>\<forall>x \<in> A. P x\<close>  \<open>\<exists>x \<in> A. P x\<close>
      \<open>\<forall>x \<in> A. x \<in> B\<close>  \<open>\<exists>x \<in> A. x \<in> B\<close>

    \<^item> set-theory operators
      \<open>\<Union>x \<in> A. B x\<close>  \<open>\<Inter>x \<in> A. B x\<close>
      \<open>A \<inter> B\<close>  \<open>A \<union> B\<close> \<open>- A\<close>
      \<open>A \<subseteq> B\<close>  \<open>A = B\<close>

  \<triangleright> What are the most basic Isar proofs for these rules?

  \<triangleright> Write (proven) rules in various forms:

    \<^item> closed theorem statements, using Isabelle/Pure connectives
      \<open>A \<Longrightarrow> B\<close>, \<open>\<And>x. P x\<close>

    \<^item> open theorem statements, using Isabelle/Isar keywords
      \<^theory_text>\<open>fixes x assumes "A x" shows "P x"\<close>
      \<^theory_text>\<open>obtains x where "P x"\<close>

    \<^item> open statements within a proof body

      \<^theory_text>\<open>fix x assume "P x" have "Q x"\<close>

      \<^theory_text>\<open>have "Q x" if "P x" for x\<close>

    \<^item> indirect statements within a proof body

      \<^theory_text>\<open>consider x where "P x" | y where "Q y"\<close>
\<close>

end